CREATE DATABASE [Service]
GO

CREATE TABLE Users(
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, Username VARCHAR(30) UNIQUE NOT NULL
, [Password] VARCHAR(50) NOT NULL
, [Name] VARCHAR(50)
, Birthdate DATETIME2
, Age INT CHECK (Age>=14 AND Age<=110)
, Email VARCHAR(50) NOT NULL  
)

CREATE TABLE Departments (
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, [Name] VARCHAR(50) NOT NULL
)

CREATE TABLE Employees (
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, FirstName VARCHAR(30) UNIQUE NOT NULL
, LastName VARCHAR(50) NOT NULL
, Birthdate DATETIME2
, Age INT CHECK (Age>=14 AND Age<=110)
, DepartmentId INT 
CONSTRAINT FK_Employees_Departments 
FOREIGN KEY (DepartmentId)
REFERENCES Departments (Id)
)

CREATE TABLE Categories (
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, [Name] VARCHAR(50) NOT NULL
, DepartmentId INT NOT NULL
CONSTRAINT FK_Categories_Departments 
FOREIGN KEY (DepartmentId)
REFERENCES Departments (Id)
)

CREATE TABLE [Status] (
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, Label VARCHAR(30) NOT NULL
)

CREATE TABLE Reports (
  Id INT IDENTITY PRIMARY KEY NOT NULL 
, CategoryId INT NOT NULL
CONSTRAINT FK_Reports_Categories
FOREIGN KEY (CategoryId)
REFERENCES Categories (Id)
, StatusId INT NOT NULL
CONSTRAINT FK_Reports_Status
FOREIGN KEY (StatusId)
REFERENCES [Status] (Id)
, OpenDate DATETIME2 NOT NULL
, CloseDate DATETIME2
, [Description] VARCHAR(200) NOT NULL
, UserId INT NOT NULL
CONSTRAINT FK_Reports_Users
FOREIGN KEY (UserId)
REFERENCES Users (Id)  
, EmployeeId INT
CONSTRAINT FK_Reports_Emplloyees
FOREIGN KEY (EmployeeId)
REFERENCES Employees (Id)  
)